const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const patient_profiles = sequelize.define(
    'patient_profiles',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      health_metrics: {
        type: DataTypes.TEXT,
      },

      prescriptions: {
        type: DataTypes.TEXT,
      },

      appointments: {
        type: DataTypes.TEXT,
      },

      billing: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  patient_profiles.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.patient_profiles.belongsTo(db.subscribers, {
      as: 'subscriber',
      foreignKey: {
        name: 'subscriberId',
      },
      constraints: false,
    });

    db.patient_profiles.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.patient_profiles.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.patient_profiles.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return patient_profiles;
};
